#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "muGUI.h"

 

void muGUIwidget_init ( muGUIwidget * fwid , unsigned char ftype , int fx , int fy , unsigned int fw , unsigned int fh , char * fTitle ) 
{	
			
	fwid->Type = ftype ;
	fwid->x = fx;
	fwid->y = fy;
	fwid->w = fw;
	fwid->h = fh;

	/*Copy the Widget Title*/	
	memset(fwid->Title,0,56);
	strcpy(fwid->Title,fTitle);

	/*On Create the widget need to be display*/
	fwid->NeedRefresh = TRUE;
	fwid->Status = MUGUI_WID_STATUS_SHOW;
	
	/*All the widget has the same external draw*/
	fwid->external_draw = muGUIwidget_external_draw;

	/*Test if Title bar is click*/
	fwid->isClick = muGUIwidget_isClick_TitleBar;
	
	/*Default*/
	fwid->image = NULL; 
	fwid->addImage 	= NULL;
	fwid->TextBuffer = NULL;
	
	
	switch ( ftype ) {
		case MUGUI_WID_IMAGE : {
		
			fwid->internal_draw = muGUIwidget_image_internal_draw;
			fwid->addImage = muGUIwidget_attachImage;
			break;	
		}

		case MUGUI_WID_TEXT : {
		
			fwid->internal_draw = muGUIwidget_text_internal_draw;
			fwid->addText = muGUIwidget_addText;
			
			/*create memory for the current text*/
			fwid->TextBuffer = ( muGUIChainedText * ) malloc ( sizeof ( struct _muGUIChainedText ) * sizeof(char) );

			fwid->TextBuffer->next = NULL;
			fwid->TextBuffer->previous = NULL;
		
			fwid->maxLines = (unsigned int)( (fh - 22 ) /  11 );
			fwid->displayAtLine = 0 ;
			
			break;	
		}		
		
		
		default: {
			fwid->internal_draw = muGUIwidget_default_internal_draw;
			
		}
	}
	
		
	
}

/*
Create the outer box of the widget with the title Bar and text
*/
void muGUIwidget_external_draw ( void * this , void * fgui ) {

	SDL_Rect rect;
	SDL_Color rgb;
	Uint32 color;


	
	muGUIwidget * zWid;
	muGUI * zgui;
	
	zWid = (muGUIwidget*)this;
	zgui = (muGUI*)fgui;
	

	//Outer Rect  	
	rgb.r = 0x00;
	rgb.g = 0x25;	
	rgb.b = 0x49;	
	color = SDL_MapRGB(zgui->MainScreen->format, rgb.r, rgb.g, rgb.b);
	SDL_drawLine(zgui->MainScreen, zWid->x, 			zWid->y, 			zWid->x + zWid->w , zWid->y, 			color);
	SDL_drawLine(zgui->MainScreen, zWid->x + zWid->w,	zWid->y, 			zWid->x + zWid->w , zWid->y + zWid->h,	color);
	SDL_drawLine(zgui->MainScreen, zWid->x , 			zWid->y + zWid->h , zWid->x + zWid->w , zWid->y + zWid->h, 	color);
	SDL_drawLine(zgui->MainScreen, zWid->x , 			zWid->y, 			zWid->x , 			zWid->y + zWid->h, 	color);
	SDL_drawLine(zgui->MainScreen, zWid->x , zWid->y + 21, zWid->x + zWid->w - 2 , zWid->y + 21 , 	color);	
	
	
	rgb.r = 0x00;
	rgb.g = 0x65;	
	rgb.b = 0x89;	
	color = SDL_MapRGB(zgui->MainScreen->format, rgb.r, rgb.g, rgb.b);
  	rect.x = zWid->x+1;
  	rect.y = zWid->y+1;
  	rect.w = zWid->w-2;
  	rect.h = 20;
  	SDL_FillRect(zgui->MainScreen, &rect, color);

	//zgui->Font3 = SetFontColor(zgui->Font1,0,0,0);
	PrintStringFont  (zgui->MainScreen, zgui->Font1,zWid->x + 2, zWid->y+2, zWid->Title );
	
	rgb.r = 0xCC;
	rgb.g = 0xCC;	
	rgb.b = 0xCC;	
	color = SDL_MapRGB(zgui->MainScreen->format, rgb.r, rgb.g, rgb.b);
  	rect.x = zWid->x+zWid->w-22;
  	rect.y = zWid->y+3;
  	rect.w = 16;
  	rect.h = 16;
  	SDL_FillRect(zgui->MainScreen, &rect, color);	
	
	
}


/*
Default Internal Widget Draw fonction : Fill Rectangle
*/
void muGUIwidget_default_internal_draw ( void * this , void * fgui ) {
	SDL_Rect rect;
	SDL_Color rgb;
	Uint32 color;

	muGUIwidget * zWid;
	muGUI * zgui;
	
	zWid = (muGUIwidget*)this;
	zgui = (muGUI*)fgui;
	
	rgb.r = 0xAA;
	rgb.g = 0xAA;	
	rgb.b = 0xAA;	
	color = SDL_MapRGB(zgui->MainScreen->format, rgb.r, rgb.g, rgb.b);
	rect.x = zWid->x+1;
	rect.y = zWid->y+22;
	rect.w = zWid->w-2;
	rect.h = zWid->h-22;
	SDL_FillRect(zgui->MainScreen, &rect, color);
  
	
	
}

/*
Image widget Internal Draw : Blit to Main screen Surface
*/
void muGUIwidget_image_internal_draw ( void * this , void * fgui ) {

	SDL_Rect rect;


	
	muGUIwidget * zWid;
	muGUI * zgui;
	
	zWid = (muGUIwidget*)this;
	zgui = (muGUI*)fgui;
	
	
	rect.x = zWid->x+1;
	rect.y = zWid->y+22;
	rect.w = zWid->w-2;
	rect.h = zWid->h-22;
 			
			
			
	SDL_BlitSurface(zWid->image , NULL, zgui->MainScreen, &rect);

	
}




int  muGUIwidget_isClick_TitleBar ( void * this , void * fgui , int fx , int fy) {
	
	muGUIwidget * zWid;
	muGUI * zgui;
	
	zWid = (muGUIwidget*)this;
	zgui = (muGUI*)fgui;
	

	if ( (( fx > zWid->x) && ( fx < ( zWid->x + zWid->w  ))) && 
		 (( fy > zWid->y) && ( fy < ( zWid->y + 22 )))	) {
		 	
		 	if ( fx > ( zWid->x + zWid->w - 20 )) return (MUGUI_WID_TITLEBAR_BUTTON_1) ;
		 	
		 	else return ( MUGUI_WID_TITLEBAR_OTHER );
		 	
		}
		
	else return ( FALSE );	
		

}


void muGUIwidget_attachImage ( void * this , SDL_Surface * surface ) {
	
	muGUIwidget * zWid;

	zWid = (muGUIwidget*)this;

	zWid->image = surface;	
	
}

void muGUIwidget_addText ( void * this , char * ftext ) {

	muGUIChainedText * currentText;
	muGUIChainedText * previousText;
	muGUIChainedText * nextText;		
	muGUIwidget * zWid;
	
	unsigned int nbLigne;
	
	zWid = (muGUIwidget*)this;

	currentText = zWid->TextBuffer;
	previousText = NULL;
	
	nbLigne = 1;
	
	while ( currentText->next != NULL ) {
	
		previousText = currentText;
		currentText = currentText->next;
		nbLigne = nbLigne + 1 ;
	}
	
	
	currentText->text = (char * )malloc ( strlen ( ftext ) * sizeof ( char ) );
	strcpy( currentText->text , ftext );
	
	currentText->previous = previousText;

	if ( nbLigne < zWid->maxLines ) zWid->displayAtLine = 0;
	else zWid->displayAtLine = nbLigne - zWid->maxLines ;

	zWid->NeedRefresh = TRUE;


	//create memory for the next text
	currentText->next = ( muGUIChainedText * ) malloc ( sizeof ( struct _muGUIChainedText ) * sizeof(char) );
	nextText = currentText->next;
	
	nextText->next = NULL;
	nextText->previous = currentText;
	
}

void muGUIwidget_printAllText ( void * this ) {

	muGUIChainedText * currentText;
	muGUIwidget * zWid;

	
	zWid = (muGUIwidget*)this;
	currentText = zWid->TextBuffer;
	
	
	while ( currentText->next != NULL ) {
	
		printf("-%s-\n",currentText->text);
		
		currentText = currentText->next;
	}
	
	
	
}


/*
*/
void muGUIwidget_text_internal_draw ( void * this , void * fgui ) {
	SDL_Rect rect;
	SDL_Color rgb;
	Uint32 color;
	unsigned int boucle;
	unsigned int Ypos;
	unsigned int currentLine;

	muGUIwidget * zWid;
	muGUI * zgui;
	muGUIChainedText * currentText;
	
	zWid = (muGUIwidget*)this;
	zgui = (muGUI*)fgui;
	
	/*Draw the background*/	
	rgb.r = 0x00;
	rgb.g = 0x00;	
	rgb.b = 0x00;	
	color = SDL_MapRGB(zgui->MainScreen->format, rgb.r, rgb.g, rgb.b);
	rect.x = zWid->x+1;
	rect.y = zWid->y+22;
	rect.w = zWid->w-2;
	rect.h = zWid->h-22;
	SDL_FillRect(zgui->MainScreen, &rect, color);


	/*get the correct text*/
	currentText = zWid->TextBuffer;
	
	for ( boucle = 0 ; boucle < zWid->displayAtLine ; boucle++ ){
		currentText = currentText->next;
	}
	
	/*initialisation*/
	Ypos = rect.y ;
	//KBF_SetColor(0, 0, 0);	
	currentLine = 0;

	/*Draw the text*/
	while ( ( currentText->next != NULL ) &&  ( currentLine < zWid->maxLines ) ) {
	
		PrintStringFont  (zgui->MainScreen, zgui->Font2,rect.x + 2, Ypos, currentText->text );
		//KBF_Write(zgui->font, zgui->MainScreen, rect.x + 2, Ypos  , currentText->text);	
		Ypos = Ypos + FontHeight(zgui->Font2) ;

		currentText = currentText->next;
		currentLine = currentLine + 1;
	}
  
	
	
	
	
	
}